///////////////////////////////////////////////////////////////////////////////
//
//  File Name:  permission.h
//
//  Description:  Header file for permission.rul
//
//  Reference:	http://msdn2.microsoft.com/en-us/library/aa446645.aspx
//				http://msdn.microsoft.com/en-us/library/aa379579(VS.85).aspx
//				http://msdn.microsoft.com/en-us/library/aa379576(VS.85).aspx
//				http://msdn.microsoft.com/en-us/library/aa375213(VS.85).aspx   
//				http://msdn.microsoft.com/en-us/library/aa446631(VS.85).aspx
//				http://msdn.microsoft.com/en-us/library/aa446627(VS.85).aspx
//				http://msdn.microsoft.com/en-us/library/aa379636(VS.85).aspx
//				http://msdn.microsoft.com/en-us/library/aa379649(VS.85).aspx
//				http://msdn.microsoft.com/en-us/library/aa379598(VS.85).aspx
//              http://msdn.microsoft.com/en-us/library/aa379283(VS.85).aspx
//              http://msdn.microsoft.com/en-us/library/aa446595(VS.85).aspx - if you want to set a security descriptor for a new registry key.
//
///////////////////////////////////////////////////////////////////////////////

// Windows NT Security

//generic access rights
#define GENERIC_ALL				0x10000000
#define GENERIC_READ_PERM		0x80000000
#define GENERIC_WRITE_PERM		0x40000000
#define GENERIC_EXECUTE_PERM	0x20000000
                                
//Custom( Travers folder/execute file, list folder /read data, read attributes,read extended attributes and read permissions)
//this is present if the permission is inherited can be seen in C:\WINDOWS\Microsoft.NET\Framework\v2.0.50727 for users group account can be removed.
#define CUSTOM_PERMISSION			"-1610612736"

#define	FULL_CONTROL				"2032127"
#define	FULL_CONTROL_INHERITED      "268435456"
                                                
//this is the least permission you need
#define	READEXECLIST_ACCESSMASK		"1179817"

#define READONLY_ACCESSMASK			"1179785"
#define WRITE_ACCESSMASK			"1048854"
#define MODIFY_ACCESSMASK			"1245631"

#define	WRITE_ACCESS_MASK		"2"
#define	APPEND_ACCESS_MASK		"4"

//This is the default permission for the network services in c:\windows\temp
#define LISTDELETE_ACCESSMASK		"1114113"

//This is for the KPContentUser special permissions on c:\windows\temp
#define DELETE_ACCESSMASK			"65536"

//This is the default permission for the users group in c:\windows\temp
#define TRAVERSECREATE_ACCESSMASK	"1048614"

//This is the permission you need for the network services in c:\windows\temp if the users group is missing.
#define TRAVERSEWRITEDEL_ACCESSMASK	"1114391"

//This is the permission for the network services in c:\windows\temp if you select Read, List folder contents, Read and Write permissions 
#define READLISTWRITE_ACCESSMASK "1180095"

//This is the default permission for the IIS_USRS in c:\windows\temp List folder/Read data permissions 
#define LISTREAD_ACCESSMASK "1048577"

//This is the default permission for the NETWORK SERVICE in C:\WINDOWS\Microsoft.NET\Framework\v2.0.50727\Temporary ASP.NET Files permissions 
#define MODIFYTRAVERSE_ACCESSMASK "1507839"

//This is the needed permission for the KPContentUser in C:\WINDOWS\Temp permissions 
#define MODIFYSPECIAL_ACCESSMASK "1245695"

#define DENYREADEXECLIST_ACCESSMASK	"131241"
#define DENYREADONLY_ACCESSMASK     "131209"
#define DENYWRITE_ACCESSMASK		"278"
#define	DENYMODIFY_ACCESSMASK		"197055"

#define	ALLOW_ACCESSTYPE		"0"
#define	DENY_ACCESSTYPE			"1" 

#define	DENY_CHANGE_PERM		"262144"
#define	DENY_TAKE_OWNERSHIP		"524288"
#define	DENY_CHANGE_AND_TAKE	"786432"

#define FILE_DELETE				0x00010000
/*#define FILE_LIST_DIRECTORY		0x0001    // directory
#define FILE_ADD_FILE			0x0002    // directory
#define FILE_ADD_SUBDIRECTORY	0x0004    // directory
#define FILE_READ_EA			0x0008    // file & directory
#define FILE_WRITE_EA			0x0010    // file & directory
#define FILE_TRAVERSE			0x0020    // directory
#define FILE_DELETE_CHILD		0x0040    // directory
#define FILE_READ_ATTRIBUTES	0x0080    // all
#define FILE_WRITE_ATTRIBUTES	0x0100    // all

#define FILE_READ_DATA			0x0001    // file & pipe
#define FILE_WRITE_DATA			0x0002    // file & pipe
#define FILE_APPEND_DATA		0x0004    // file
#define FILE_EXECUTE			0x0020    // file*/

//definition used in GetNamedSecurityInfoA and SetNamedSecurityInfoA
	   
//typedef SE_OBJECT_TYPE
#define SE_UNKNOWN_OBJECT_TYPE	0
#define SE_FILE_OBJECT			1
#define SE_SERVICE				2
#define SE_PRINTER				3
#define SE_REGISTRY_KEY			4
#define	SE_LMSHARE				5
#define SE_KERNEL_OBJECT		6
#define SE_WINDOW_OBJECT		7
#define	SE_DS_OBJECT			8
#define	SE_DS_OBJECT_ALL		9
#define	SE_PROVIDER_DEFINED_OBJECT	10
#define	SE_WMIGUID_OBJECT		11
#define	SE_REGISTRY_WOW64_32KEY	12

//security information
#define OWNER_SECURITY_INFORMATION  0x00000001
#define GROUP_SECURITY_INFORMATION  0x20000000
#define DACL_SECURITY_INFORMATION	0x00000004
#define SACL_SECURITY_INFORMATION	0x00000008
	
#define UNPROTECTED_SACL_SECURITY_INFORMATION	0x10000000
#define UNPROTECTED_DACL_SECURITY_INFORMATION	0x20000000
#define PROTECTED_SACL_SECURITY_INFORMATION	0x40000000
#define PROTECTED_DACL_SECURITY_INFORMATION 0x80000000

//definition used in SetEntriesInAclA
	
//typedef ACCESS_MODE
#define NOT_USED_ACCESS	0
#define GRANT_ACCESS	1
#define SET_ACCESS		2
#define DENY_ACCESS		3
#define REVOKE_ACCESS	4

#define NO_INHERITANCE				0x0	
#define SUB_OBJECTS_ONLY_INHERIT	0x1
#define SUB_CONTAINERS_ONLY_INHERIT	0x2
#define SUB_CONTAINERS_AND_OBJECTS_INHERIT  0x3
#define INHERIT_NO_PROPAGATE		0x4
#define INHERIT_ONLY				0x8
#define INHERITED_ACCESS_ENTRY		0x10
#define INHERITED_PARENT			0x10000000
#define INHERITED_GRANDPARENT		0x20000000
	
//typedef MULTIPLE_TRUSTEE_OPERATION  
#define NO_MULTIPLE_TRUSTEE       0
#define MULTIPLE_TRUSTEE_OPERATION	1
	
//typedef TRUSTEE_FORM	
#define TRUSTEE_IS_SID		0
#define TRUSTEE_IS_NAME		1
#define	TRUSTEE_BAD_FORM	2
#define	TRUSTEE_IS_OBJECTS_AND_SID	3
#define	TRUSTEE_IS_OBJECTS_AND_NAME	4

//typedef TRUSTEE_TYPE
#define TRUSTEE_IS_UNKNOWN	0
#define	TRUSTEE_IS_USER		1
#define	TRUSTEE_IS_GROUP	2
#define	TRUSTEE_IS_DOMAIN	3
#define	TRUSTEE_IS_ALIAS	4
#define	TRUSTEE_IS_WELL_KNOWN_GROUP	5
#define	TRUSTEE_IS_DELETED	6
#define	TRUSTEE_IS_INVALID	7
#define	TRUSTEE_IS_COMPUTER	8

//typedef SID_NAME_USE
#define SID_TYPE_USER			1
#define SID_TYPE_GROUP			2		
#define SID_TYPE_DOMAIN			3
#define SID_TYPE_ALIAS			4
#define SID_TYPE_WELLKNOWNGROUP	5
#define SID_TYPE_DELETEDACCOUNT	6
#define SID_TYPE_INVALID		7
#define SID_TYPE_UNKNOWN		8
#define SID_TYPE_COMPUTER		9
#define SID_TYPE_LABEL			10
	
//definition used in AllocateAndInitializeSid
#define SECURITY_BUILTIN_DOMAIN_RID 0x00000020 //sandeep 32
#define DOMAIN_ALIAS_RID_ADMINS 0x00000220 //sandeep
#define DOMAIN_ALIAS_RID_USERS 0x00000221 
#define DOMAIN_ALIAS_RID_GUESTS 0x00000222
#define DOMAIN_ALIAS_RID_POWER_USERS 0x00000223
#define DOMAIN_ALIAS_RID_ACCOUNT_OPS 0x00000224
#define DOMAIN_ALIAS_RID_SYSTEM_OPS 0x00000225
#define DOMAIN_ALIAS_RID_PRINT_OPS 0x00000226
#define DOMAIN_ALIAS_RID_BACKUP_OPS 0x00000227
#define DOMAIN_ALIAS_RID_REPLICATOR 0x00000228
	
// Windows Security: TRUSTEE structure
typedef TRUSTEE
begin
	POINTER pMultipleTrustee;
	LONG    MultipleTrusteeOperation;
	LONG    TrusteeForm;
	LONG    TrusteeType;
	POINTER ptstrName; 		
end;

// Windows Security: EXPLICIT_ACCESS structure use in SetEntriesInAclA
typedef EXPLICIT_ACCESS
begin
	NUMBER  grfAccessPermissions;
	LONG    grfAccessMode;
	NUMBER  grfInheritance;
	TRUSTEE Trustee;		
end;

/////////////////////////////////////////////////////////////////////////////
// Windows Security: SID_IDENTIFIER_AUTHORITY
// SID identifier authority values
//                                                                         //
// Universal well-known SIDs                                               //
//                                                                         //
//     Null SID                     S-1-0-0                                //
//     World                        S-1-1-0                                //
//     Local                        S-1-2-0                                //
//     Creator Owner ID             S-1-3-0                                //
//     Creator Group ID             S-1-3-1                                //
//     Creator Owner Server ID      S-1-3-2                                //
//     Creator Group Server ID      S-1-3-3                                //
//                                                                         //
//     (Non-unique IDs)             S-1-4                                  //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////


#define	SECURITY_NULL_SID_AUTHORITY	0
#define	SECURITY_WORLD_SID_AUTHORITY	1
#define	SECURITY_LOCAL_SID_AUTHORITY	2
#define	SECURITY_CREATOR_SID_AUTHORITY	3
#define	SECURITY_NON_UNIQUE_AUTHORITY	4
#define	SECURITY_NT_AUTHORITY	5
#define	SECURITY_RESOURCE_MANAGER_AUTHORITY	9

typedef SID_IDENTIFIER_AUTHORITY
begin
   	CHAR Value1;
   	CHAR Value2;
   	CHAR Value3;
   	CHAR Value4;
   	CHAR Value5;
   	CHAR Value6; 
end;

#define SECURITY_NULL_RID                 (0x00000000L)
#define SECURITY_WORLD_RID                (0x00000000L)
#define SECURITY_LOCAL_RID                (0X00000000L)

#define SECURITY_CREATOR_OWNER_RID        (0x00000000L)
#define SECURITY_CREATOR_GROUP_RID        (0x00000001L)

#define SECURITY_CREATOR_OWNER_SERVER_RID (0x00000002L)
#define SECURITY_CREATOR_GROUP_SERVER_RID (0x00000003L)

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// NT well-known SIDs                                                      //
//                                                                         //
//     NT Authority          S-1-5                                         //
//     Dialup                S-1-5-1                                       //
//                                                                         //
//     Network               S-1-5-2                                       //
//     Batch                 S-1-5-3                                       //
//     Interactive           S-1-5-4                                       //
//     Service               S-1-5-6                                       //
//     AnonymousLogon        S-1-5-7       (aka null logon session)        //
//     Proxy                 S-1-5-8                                       //
//     ServerLogon           S-1-5-9       (aka domain controller account) //
//     Self                  S-1-5-10      (self RID)                      //
//     Authenticated User    S-1-5-11      (Authenticated user somewhere)  //
//     Restricted Code       S-1-5-12      (Running restricted code)       //
//                                                                         //
//     (Logon IDs)           S-1-5-5-X-Y                                   //
//                                                                         //
//     (NT non-unique IDs)   S-1-5-0x15-...                                //
//                                                                         //
//     (Built-in domain)     s-1-5-0x20                                    //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#define SECURITY_DIALUP_RID             (0x00000001L)
#define SECURITY_NETWORK_RID            (0x00000002L)
#define SECURITY_BATCH_RID              (0x00000003L)
#define SECURITY_INTERACTIVE_RID        (0x00000004L)
#define SECURITY_SERVICE_RID            (0x00000006L)
#define SECURITY_ANONYMOUS_LOGON_RID    (0x00000007L)
#define SECURITY_PROXY_RID              (0x00000008L)
#define SECURITY_ENTERPRISE_CONTROLLERS_RID (0x00000009L)
#define SECURITY_SERVER_LOGON_RID       SECURITY_ENTERPRISE_CONTROLLERS_RID
#define SECURITY_PRINCIPAL_SELF_RID     (0x0000000AL)
#define SECURITY_AUTHENTICATED_USER_RID (0x0000000BL)
#define SECURITY_RESTRICTED_CODE_RID    (0x0000000CL)

#define SECURITY_LOGON_IDS_RID          (0x00000005L)
#define SECURITY_LOGON_IDS_RID_COUNT    (3L)

#define SECURITY_LOCAL_SYSTEM_RID       (0x00000012L)

#define SECURITY_NT_NON_UNIQUE          (0x00000015L)

#define	WINDIRTEMP WINDIR ^ "temp"
#define DOTNETDIR WINDIR ^ "Microsoft.NET" ^ "Framework" ^ "v2.0.50727"
#define DOTNETDIRX64 WINDIR ^ "Microsoft.NET" ^ "Framework64" ^ "v2.0.50727"
#define DOTNETDIR_ASPNET WINDIR ^ "Microsoft.NET" ^ "Framework" ^ "v2.0.50727" ^ "Temporary ASP.NET Files"
#define DOTNETDIRX64_ASPNET WINDIR ^ "Microsoft.NET" ^ "Framework64" ^ "v2.0.50727" ^ "Temporary ASP.NET Files"

// Windows Security
prototype LONG advapi32.GetNamedSecurityInfoA(BYREF STRING, LONG, LONG, POINTER, POINTER, POINTER, POINTER, POINTER);
prototype LONG advapi32.SetNamedSecurityInfoA(BYREF STRING, LONG, LONG, POINTER, POINTER, POINTER, POINTER);
prototype LONG advapi32.SetEntriesInAclA(LONG, POINTER, POINTER, POINTER);
prototype BOOL advapi32.LookupAccountSidW(POINTER, BYVAL POINTER, BYREF WSTRING, POINTER, BYREF WSTRING, POINTER, POINTER);

prototype LONG advapi32.AllocateAndInitializeSid(POINTER, CHAR, LONG, LONG, LONG, LONG, LONG, LONG, LONG, LONG, POINTER);
prototype LONG advapi32.FreeSid(LONG);                                                                      
	
// Common Windows API
prototype LONG KERNEL.LocalFree(HWND);

// Function prototypes    

NUMBER 	nSecurityInformation;
NUMBER	nAccessPermission;
NUMBER	nSecurityAuthority;
NUMBER	nSubAuthorityCount;
NUMBER	nSubAuthority0;
NUMBER	nSubAuthority1;
NUMBER	nSubAuthority2;
NUMBER	nSubAuthority3;
NUMBER	nSubAuthority4;
NUMBER	nSubAuthority5;
NUMBER	nSubAuthority6;
NUMBER	nSubAuthority7;
STRING	szFolderPathToCheck;
STRING	szWindowsGroupName;

BOOL	bFoundRights;
BOOL	bFoundNetServ;
BOOL	bFoundASPNET;
BOOL	bFoundUsersGroup;
BOOL	bFoundIISWPG;
BOOL	bFoundAuthUser;
BOOL	bFoundAnonymous;
BOOL	bFoundIUSR;
BOOL	bFoundIISIUSR;
BOOL	bFoundUserRights;
BOOL	bFoundAuthUserRights;
BOOL	bFoundAnonymousRights;
BOOL	bFoundDNetRights;
BOOL	bFoundASPNetRights;
BOOL	bFoundIISWPGRights;
BOOL	bFoundIUSRRights;
BOOL	bFoundIISIUSRRights;


LIST	listNeedASPNET;
LIST	listNeedNetServ;
LIST	listNeedAnonymous;
LIST	listNeedAll;  //this is if you need aspnet,network services and/or Anonymous account
LIST	listSetWrite;

LIST	listNeedNetSrvWrite; //Needs Network Service write access
LIST	listNeedASPNETWrite; //Needs ASPNET write access

BOOL	bNeedASPNET;
BOOL	bNeedNetServ;
BOOL	bNeedAnonymous;
BOOL	bNeedAll;
//BOOL	bNetServSetWrite; //this flag is set if you need to add write permission for NETWORK SERVICES
//BOOL	bASPNETSetWrite; //this flag is set if you need to add write permission for ASPNET
BOOL	bChangeFolderDesc; //this flag is set to change the description in the dialog.
BOOL	bSetWrite;
    
//variables used for ASPNET SID
NUMBER	nUSERSecAuth;
NUMBER	nUSERSubAuth0;
NUMBER	nUSERSubAuth1;
NUMBER	nUSERSubAuth2;
NUMBER	nUSERSubAuth3;
NUMBER	nUSERSubAuth4;
NUMBER	nUSERSubAuth5;
NUMBER	nUSERSubAuth6;
NUMBER	nUSERSubAuth7;

//variables used for IUSR SID
NUMBER	nIUSRSecAuth;
NUMBER	nIUSRSubAuth0;
NUMBER	nIUSRSubAuth1;
NUMBER	nIUSRSubAuth2;
NUMBER	nIUSRSubAuth3;
NUMBER	nIUSRSubAuth4;
NUMBER	nIUSRSubAuth5;
NUMBER	nIUSRSubAuth6;
NUMBER	nIUSRSubAuth7;

STRING	szUsersGrpAcct;
STRING	szNETSERVAcct; 
STRING	szAuthUserAcct;   
STRING	szIUSRAcct;
STRING	szIISIUSRAcct;

//this will store account names with domain
STRING	szDUsersGrpAcct;
STRING	szDNETSERVAcct;
STRING	szDAuthUserAcct;
STRING 	szDIUSRAcct;
STRING 	szDIISIUSRAcct;

//this will store all the SID per account
STRING	szNetSID; //Network Service SID
STRING	szUserSID; //Users Group SID 
STRING	szAnonymousSID; //Anonymous SID
STRING	szAuthUserSID; //Authenticated Users SID 
STRING	szASPSID; //ASPNET SID
STRING	szIUSRSID; //IUSR SID 
STRING	szIISWPGSID; //IIS_WPG SID
STRING	szIISIUSRSSID; //IIS_IUSRS

BOOL	bAnonymousMemofUser; //flag to set if Anonymous account is part of the users group
BOOL	bASPNETMemofUser; //flag to set if ASPNET account is part of the users group
BOOL	bNETServMemofUser; //flag to set if Network Service account is part of the users group
BOOL	bAuthUserMemofUser; //flag to set if Authenticated Users account is part of the users group
BOOL	bIISWPGMemofUser; //flag to set if IIS_WPG account is part of the users group
BOOL	bIUSRMemofUser; //flag to set if IIS_WPG account is part of the users group

BOOL	bAnonymousMemofIISWPG; //flag to set if Anonymous account is part of the IIS_WPG
BOOL	bASPNETMemofIISWPG; //flag to set if ASPNET account is part of the IIS_WPG
BOOL	bNETServMemofIISWPG; //flag to set if Network Service account is part of the IIS_WPG
BOOL	bAuthUserMemofIISWPG; //flag to set if Authenticated Users account is part of the IIS_WPG
BOOL	bIUSRMemofIISWPG; //flag to set if IIS_WPG account is part of the IIS_WPG

BOOL	bAnonymousMemofIISIUSRS; //flag to set if Anonymous account is part of the IIS_IUSRS
BOOL	bNETServMemofIISIUSRS; //flag to set if Network Service account is part of the IIS_IUSRS
BOOL	bAuthUserMemofIISIUSRS; //flag to set if Authenticated Users account is part of the IIS_IUSRS
BOOL	bIUSRMemofIISIUSRS; //flag to set if IIS_WPG account is part of the IIS_IUSRS

STRING	szAnonymousAcct; //store the IIS anonymous acct
STRING 	szAnonymousAcctDomain; //store the domain for the IIS anonymous acct
STRING	szAnonymousFullAcct; //store the IIS anonymous acct with domain

//STRING	szCompDomain; //store the domain information
STRING 	szCompHost; //store the computer name

//Master Group Membership lists
LIST	listUsersGrpAcctGroups;
LIST	listASPNETAcctGroups;
LIST	listNETSERVAcctGroups; 
LIST	listAuthUserAcctGroups;   
LIST	listIUSRAcctGroups;
LIST	listIISIUSRAcctGroups;
LIST	listAnonymousAcctGroups; //store the IIS anonymous acct 
LIST	listIISWPGAcctGroups;
LIST	listUsersGrpAcctLocalGroups;
LIST	listASPNETAcctLocalGroups;
LIST	listNETSERVAcctLocalGroups; 
LIST	listAuthUserAcctLocalGroups;   
LIST	listIUSRAcctLocalGroups;
LIST	listIISIUSRAcctLocalGroups;
LIST	listAnonymousAcctLocalGroups; //store the IIS anonymous acct 
LIST	listIISWPGAcctLocalGroups;

BOOL	bAnonymousLocal; //flag use to determine if the Anonymous user is a local account 

//KCenter Content Tools User acct lists
LIST	listNeedKPContentUser;
LIST	listNeedKPContentUserWrite;
LIST	listNeedKPContentUserWriteOnFolderOnly;
LIST	listNeedKPContentUserModify;
LIST	listNeedKPContentUserOnFile;
LIST	listKPContentBinFolderToCheck; //create a list of folders that don't yet exist from Acadia
LIST	listKPContentFileToCheck; //create a list of web.config files that don't yet exist from Acadia
LIST	listGenericAcctLocalGroups;
LIST	listGenericAcctNestedGroups;
//generic accounts needed on KPContent folder
LIST	listNeedAnonymousReadOnly;
LIST	listNeedNetSrvReadOnly;
LIST	listNeedASPNETReadOnly;

//Flags for specific account membership
BOOL	bSpecificAcctMemofUser; //flag to set if specific account is part of the users group
BOOL	bSpecificAcctMemofIISWPG; //flag to set if specific account is part of the IIS_WPG
BOOL	bSpecificAcctMemofIISIUSRS; //flag to set if specific account is part of the IIS_IUSRS
BOOL	bSpecificLocal; //flag use to determine if the specific user is a local account
BOOL	bNeedSpecific;
STRING	szSpecificSID; //SID for specific account
